using namespace std;
#include <iostream>
#include <fstream>
#include <math.h>

#include "TMinuit.h"

void ftest( int& npar, double* grad, double& fval, double* xval, 
            int flag );

int main() {

  int ilun = 5;
  int olun = 6;
  int elun = 7;

  TMinuit rmin( 3 );
  rmin.SetFCN( ftest );
  double arglis[10];
  int ierror;
  rmin.mninit( ilun, olun, elun );
  rmin.DefineParameter( 0, "x", 0.0, 0.1, 0.0, 0.0 );
  rmin.DefineParameter( 1, "z", 0.0, 0.1, 0.0, 0.0 );
  rmin.DefineParameter( 2, "y", 0.0, 0.1, 0.0, 0.0 );
  arglis[0] = 1.0;
  rmin.mnexcm( "call fcn", arglis, 1, ierror );
  arglis[0] = 2.0;
  rmin.mnexcm(      "fix", arglis, 1, ierror );
  rmin.mnexcm(   "migrad", arglis, 0, ierror );
  rmin.mnexcm(    "minos", arglis, 0, ierror );
  rmin.mnexcm(     "stop", arglis, 0, ierror );
  int ipar;
  for ( ipar = 0; ipar < 3; ipar++ ) {
    TString name;
    double pval;
    double pmin;
    double pmax;
    double errp;
    double errl;
    double errh;
    int ivar;
    double erro;
    double cglo;
    rmin.mnpout( ipar, name, pval, erro, pmin, pmax, ivar );
    rmin.mnerrs( ipar, errp, errl, errh, cglo );
    cout << "parameter " << ipar << ": " << name << " "
         << pval << " " << erro << " " << pmin << " " << pmax << " " << ivar
         << endl << "      "
         << errp << " " << errl << " " << errh << endl;
  }

  return 0;

}

void ftest( int& npar, double* grad, double& fval, double* xval, 
            int flag ) {
  static float ca;
  static float cb;
  static float cc;
  static float cd;
  static float ce;
  static float cf;
  static float cg;
  if ( flag == 1 ) {
    ifstream file( "parameters.dat" );
    file >> ca >> cb >> cc >> cd >> ce >> cf >> cg;
    cout << "input parameters: "
         << ca << " " << cb << " " << cc << " " << cd << " "
         << ce << " " << cf << " " << cg << endl;
  }
  fval = ( ca * pow( xval[0] - cd, 2 ) ) +
         ( cb * pow( xval[2] - ce, 2 ) ) +
         ( cc *    ( xval[0] - cf ) * ( xval[2] - cg ) );
  cout << "==> " <<  flag    << " " <<  npar    << " "
                 <<  xval[0] << " " <<  xval[2] << " " <<  fval << endl;
  return;
}

