      program main
c
      external ftest
      double precision arglis(10)
      double precision pval,pmin,pmax
      double precision errp,errl,errh
      double precision yval,erro,cglo
      character chname*20
      call mninit(5,6,17)
c
c     1.35e06 = 1.35 * 10^6 precisione singola
c     1.35d06 = 1.35 * 10^6 precisione doppia
c
      write(6,*)' define parameter 1'
      call mnparm(1,'x',0.0d00,0.1d00,0.0d00,0.0d00,ierror)
      write(6,*)' parameter 1 defined, status = ',ierror
      write(6,*)' define parameter 2'
      call mnparm(2,'y',0.0d00,0.1d00,0.0d00,0.0d00,ierror)
      write(6,*)' parameter 2 defined, status = ',ierror
      write(6,*)' set title'
      call mnseti('minimization batch')
c
      write(6,*)' call FCN with IFLAG=1'
      arglis(1) = 1.0
      call mnexcm(ftest,'call fcn',arglis,1,ierror,0)
      write(6,*)' FCN called, status = ',ierror
      write(6,*)' do MIGRAD minimization'
      call mnexcm(ftest,'migrad'  ,arglis,0,ierror,0)
      write(6,*)' MIGRAD done, status = ',ierror
      write(6,*)' do MINOS error computation'
      call mnexcm(ftest,'minos'   ,arglis,0,ierror,0)
      write(6,*)' MINOS error computation done, status = ',ierror
      call mnexcm(ftest,'stop'    ,arglis,0,ierror,0)
      write(6,*)' end of minimization'
c
      write(6,*)' minimization result: '
      do 1000 ipar=1,2
        call mnpout(ipar,chname,pval,erro,pmin,pmax,ivarbl)
        call mnerrs(ipar,errp,errl,errh,cglo)
        write(6,*)' parameter ',ipar,': ',chname
        write(6,*)'     ---> ',pval,errp,errl,errh
 1000 continue
c
      write(6,*)' call FCN with x=1.0 and y=2.0'
      arglis(1) = 1.0
      arglis(2) = 2.0
      call mncalf(ftest,arglis,yval)
c
      write(6,*)' done'
c
      stop
      end
c
c
      subroutine ftest(npar,grad,fval,xval,iflag,futil)
c
      external futil
      double precision xval(2),grad(2)
      double precision fval
      save ca,cb,cc,cd,ce,cf,cg
c
      if(iflag.eq.1)then
         open(unit=90,file='parameters.dat',
     1        access='sequential',form='formatted',status='old')
         read(90,*)ca,cb,cc,cd,ce,cf,cg
      endif
c
      fval = (ca*((xval(1)-cd)**2))+
     1       (cb*((xval(2)-ce)**2))+
     1       (cc*((xval(1)-cf)*(xval(2)-cg)))
      write(6,*)'==> ',iflag,npar,(xval(i),i=1,2),fval
c
      return
      end


